最长连续递增序列-LeetCode
最长连续递增序列 🎯 问题描述(来源于LeetCode) 描述: 给定一个未经排序的整数数组,找到最长且 连续递增的子序列,并返回该序列的长度。 连续递增的子序列 可以由两个下标 l 和 r(l < r)确定,如果对于每个 l <= i < r,都有 nums[i] < nums[i + 1] ,那么子序列 [nums[l], nums[l + 1], ..., nums[r - 1], nums[r]] 就是连续递增子序列。 说明: 1 <= nums.length <= 104 -109 <= nums[i] <= 109 示例: 示例 1: 1234输入:nums = [1,3,5,4,7]输出:3解释:最长连续递增序列是 [1,3,5], 长度为3。尽管 [1,3,5,7] 也是升序的子序列, 但它不是连续的,因为 5 和 7 在原数组里被 4 隔开。 示例 2: 123输入:nums = [2,2,2,2,2]输出:1解释:最长连续递增序列是 [2], 长度为1。 💻 解题思路 思路1:可变长度滑动...
三数之和-LeetCode
三数之和 🎯 问题描述(来源于LeetCode) 描述: 给你一个整数数组 nums ,判断是否存在三元组 [nums[i], nums[j], nums[k]] 满足 i != j、i != k 且 j != k ,同时还满足 nums[i] + nums[j] + nums[k] == 0 。请你返回所有和为 0 且不重复的三元组。 注意:答案中不可以包含重复的三元组。 说明: 3 <= nums.length <= 3000 -105 <= nums[i] <= 105 示例: 示例 1: 12345678输入:nums = [-1,0,1,2,-1,-4]输出:[[-1,-1,2],[-1,0,1]]解释:nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0 。nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0 。nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0 。不同的三元组是 [-1,0,1] 和 [...
删除有序数组中的重复项 II-LeetCode
删除有序数组中的重复项 II 🎯 问题描述(来源于LeetCode) 描述: 给你一个有序数组 nums ,请你 原地 删除重复出现的元素,使得出现次数超过两次的元素只出现两次 ,返回删除后数组的新长度。 不要使用额外的数组空间,你必须在 原地 修改输入数组 并在使用 O(1) 额外空间的条件下完成。 说明: 1 <= nums.length <= 3 * 104 -104 <= nums[i] <= 104 nums 已按升序排列 示例: 示例 1: 123**输入:**nums = [1,1,1,2,2,3]**输出:**5, nums = [1,1,2,2,3]**解释:**函数应返回新长度 length = **`5`**, 并且原数组的前五个元素被修改为 **`1, 1, 2, 2, 3`**。 不需要考虑数组中超出新长度后面的元素。 示例 2: 123**输入:**nums = [0,0,1,1,1,1,2,3,3]**输出:**7, nums = [0,0,1,1,2,3,3]**解释:**函数应返回新长度 le...
反转字符串-LeetCode
反转字符串 🎯 问题描述(来源于LeetCode) 描述: 编写一个函数,其作用是将输入的字符串反转过来。输入字符串以字符数组 s 的形式给出。 不要给另外的数组分配额外的空间,你必须**原地修改输入数组**、使用 O(1) 的额外空间解决这一问题。 说明: 1 <= s.length <= 105 s[i] 都是 ASCII 码表中的可打印字符 示例: 示例 1: 12输入:s = ["h","e","l","l","o"]输出:["o","l","l","e","h"] 示例 2: 12输入:s = ["H","a","n","n","a","h"]输出:["h","a","n&qu...
反转字符串中的元音字母-LeetCode
反转字符串中的元音字母 🎯 问题描述(来源于LeetCode) 描述: 给你一个字符串 s ,仅反转字符串中的所有元音字母,并返回结果字符串。 元音字母包括 'a'、'e'、'i'、'o'、'u',且可能以大小写两种形式出现不止一次 说明: 1 <= s.length <= 3 * 105 s 由 可打印的 ASCII 字符组成 示例: 示例 1: 1234567输入:s = "IceCreAm"输出:"AceCreIm"解释:s中的元音是 `['I', 'e', 'e', 'A']`。反转这些元音,`s` 变为 `"AceCreIm"`. 示例 2: 123输入:s = "leetcode"输出:"leotcede" 💻 解题思路 思路1:对撞指针 思路1:代码实现 123456789101112131415class Solution: def rever...
移除元素-LeetCode
移除元素 🎯 问题描述(来源于LeetCode) 描述: 给你一个数组 nums 和一个值 val,你需要 原地 移除所有数值等于 val 的元素。元素的顺序可能发生改变。然后返回 nums 中与 val 不同的元素的数量。 假设 nums 中不等于 val 的元素数量为 k,要通过此题,您需要执行以下操作: 更改 nums 数组,使 nums 的前 k 个元素包含不等于 val 的元素。nums 的其余元素和 nums 的大小并不重要。 返回 k。 说明: 0 <= nums.length <= 100 0 <= nums[i] <= 50 0 <= val <= 100 示例: 示例 1: 1234输入:nums = [3,2,2,3], val = 3输出:2, nums = [2,2,_,_]解释:你的函数应该返回 k = 2, 并且 nums 中的前两个元素均为 2。你在返回的 k 个元素之外留下了什么并不重要(因此它们并不计入评测)。 示例 2: 12345输入:nums = [0,1,2,2,3,0,4,2], ...
长按键入-LeetCode
长按键入 🎯 问题描述(来源于LeetCode) 描述: 你的朋友正在使用键盘输入他的名字 name。偶尔,在键入字符 c 时,按键可能会被_长按_,而字符可能被输入 1 次或多次。 你将会检查键盘输入的字符 typed。如果它对应的可能是你的朋友的名字(其中一些字符可能被长按),那么就返回 True。 说明: 1 <= name.length, typed.length <= 1000 name 和 typed 的字符都是小写字母 示例: 示例 1: 123输入:name = "alex", typed = "aaleex"输出:true解释:'alex' 中的 'a' 和 'e' 被长按。 示例 2: 123输入:name = "saeed", typed = "ssaaedd"输出:false解释:'e' 一定需要被键入两次,但在 typed 的输出中不是这样。 💻 解题思路...
二分查找1-LeetCode
二分查找1 🎯 问题描述(来源于LeetCode) 描述: 给定一个 n 个元素有序的(升序)整型数组 nums 和一个目标值 target ,写一个函数搜索 nums 中的 target,如果 target 存在返回下标,否则返回 -1。 你必须编写一个具有 O(log n) 时间复杂度的算法。 说明: 你可以假设 nums 中的所有元素是不重复的。 n 将在 [1, 10000]之间。 nums 的每个元素都将在 [-9999, 9999]之间。 示例: 示例 1: 123输入: nums = [-1,0,3,5,9,12], target = 9输出 4解释 9 出现在 `nums` 中并且下标为 4 示例 2: 123输入: nums = [-1,0,3,5,9,12], target = 2输出: -1解释: 2 不存在 `nums` 中因此返回 -1 💻 解题思路 思路1:二分查找 思路1:代码实现 12345678910111213class Solution: def search(self, nums: List[int], t...
搜索插入位置-LeetCode
搜索插入位置 🎯 问题描述(来源于LeetCode) 描述: 给定一个排序数组和一个目标值,在数组中找到目标值,并返回其索引。如果目标值不存在于数组中,返回它将会被按顺序插入的位置。 请必须使用时间复杂度为 O(log n) 的算法。 说明: 1 <= nums.length <= 104 -104 <= nums[i] <= 104 nums 为 无重复元素 的 升序 排列数组 -104 <= target <= 104 示例: 示例 1: 12输入: nums = [1,3,5,6], target = 5输出: 2 示例 2: 12输入: nums = [1,3,5,6], target = 2输出: 1 💻 解题思路 思路1:二分查找 思路1:代码实现 123456789101112class Solution: def searchInsert(self, nums: List[int], target: int) -> int: left,right=0,len(nums)-1 ...
猜数字大小-LeetCode
猜数字大小 🎯 问题描述(来源于LeetCode) 描述: 我们正在玩猜数字游戏。猜数字游戏的规则如下: 我会从 1 到 n 随机选择一个数字。 请你猜选出的是哪个数字。(我选的数字在整个游戏中保持不变)。 如果你猜错了,我会告诉你,我选出的数字比你猜测的数字大了还是小了。 你可以通过调用一个预先定义好的接口 int guess(int num) 来获取猜测结果,返回值一共有三种可能的情况: -1:你猜的数字比我选出的数字大 (即 num > pick)。 1:你猜的数字比我选出的数字小 (即 num < pick)。 0:你猜的数字与我选出的数字相等。(即 num == pick)。 返回我选出的数字。 说明: 1 <= n <= 231 - 1 1 <= pick <= n 示例: 示例 1: 12输入:n = 10, pick = 6输出:6 示例 2: 12输入:n = 1, pick = 1输出:1 💻 解题思路 思路1:二分查找 思路1:代码实现 12345678910class Solution: ...













